=begin
(c) TIG & SUPodium / Cadalog 2013 - 2014
[Plugins/]Cadalog/SUPodium_Section_Tool.rb[s] loaded by SUPodium_Section_Tool.rb 
that auto-loads from the Plugins folder.
Future proofed for 2014.
Saving copies is now v2014 compliant.
=end

module SUPodium_Section_Tool ###################################################
	
	###
	IS_MAC = (RUBY_PLATFORM.downcase =~ /darwin/) != nil
	###
	HOME=File.expand_path( (begin;ENV['HOME'].dup.force_encoding('UTF-8');rescue;ENV['HOME'];end) || (begin;ENV['HOMEPATH'].dup.force_encoding('UTF-8');rescue;ENV['HOMEPATH'];end) || (begin;ENV['HOMEDRIVE'].dup.force_encoding('UTF-8');rescue;ENV['HOMEDRIVE'];end) )
	if IS_MAC
		DESKTOP=File.join(HOME, "Desktop") ### TBC
	else
		DESKTOP=File.join(HOME, "Desktop") ### PC
	end
	###
	temp = nil
	[
		(begin;Sketchup.temp_dir;rescue;'!';end), 
		(begin;ENV['TEMP'].dup.force_encoding('UTF-8');rescue;ENV['TEMP'];end), 
		(begin;ENV['TMP'].dup.force_encoding('UTF-8');rescue;ENV['TMP'];end), 
		(begin;ENV['TMPDIR'].dup.force_encoding('UTF-8');rescue;ENV['TMPDIR'];end), 
		(begin;ENV['USERPROFILE'].dup.force_encoding('UTF-8');rescue;ENV['USERPROFILE'];end),  
		'C:/Temp', 
		'/tmp', 
		CADALOG_PATH, 
		HOME, 
		DESKTOP, 
		Dir.pwd
	].each{|d|
		if d && File.directory?(d) && File.writable?(d)
			temp = File.expand_path(d)
			break
		end
    }
	TEMP = temp
	###
	TEMPDIR		= File.join(TEMP, "SUPodium_Section_Tool")
	TEMPHTML	= File.join(TEMPDIR, "Temp.html")
	###
	TOOLNAME	= ""
	SELECT_ONE	= ""
	MUST_SAVE	= ""
	NOSECTION	= ""
	COLLECTING	= ""
	ADVISOR		= ""
	HELP_DLG	= ""
	COPYING		= ""
	PROCESSING	= ""
	SAVING		= ""
	GP_NAME		= ""
	GP_MAT		= ""
	DONE_DLG	= ""
	HTML_DONE	= ""
	HTML_CLOSE	= ""
	HTML_HELP	= ""
	HTML_OK		= ""
	HTML_CANCEL	= ""
	
	def self.set_strings() #####################################################
		locale=Sketchup.get_locale.upcase
		str=File.join(CADALOG_PATH, "SUPodium_Section_Tool")
		strdef=str+"-EN-US.strings"
		strloc=str+"-#{locale}.strings"
		if File.exist?(strloc)
			strfil=strloc
		elsif File.exist?(strdef)
			strfil=strdef
		else
			if locale=="EN-US"
				UI.messagebox("#{TOOL_NAME}:\n\nThe file\n #{File.basename(strloc)}\nin\n #{CADALOG_PATH}\nis missing!\n\n\n\nCannot continue.")
				return false
			else
				UI.messagebox("#{TOOL_NAME}:\n\nThe files\n #{File.basename(strloc)}\nand\n #{File.basename(strdef)} in\n #{CADALOG_PATH}\nare missing!\n\nCannot continue.\n\n")
				return false
			end
		end
		strs=IO.read(strfil)
		stra=strs.split("==")
		strh={}
		0.step(stra.length-2, 2){|i|
			key=stra[i].gsub(/[[:space:]]/, '')
			next if key.empty? || stra[i+1].empty?
			strh[key]=stra[i+1]
		}
		###
		TOOLNAME.replace(	strh["TOOLNAME"] || "")
		SELECT_ONE.replace(	strh["SELECT_ONE"] || "")
		MUST_SAVE.replace(	strh["MUST_SAVE"] || "")
		NOSECTION.replace(	strh["NOSECTION"] || "")
		COLLECTING.replace(	strh["COLLECTING"] || "")
		ADVISOR.replace(	strh["ADVISOR"] || "")
		HELP_DLG.replace(	strh["HELP_DLG"] || "")
		COPYING.replace(	strh["COPYING"] || "")
		PROCESSING.replace(	strh["PROCESSING"] || "")
		SAVING.replace(		strh["SAVING"] || "")
		GP_NAME.replace(	strh["GP_NAME"] || "")
		GP_MAT.replace(		strh["GP_MAT"] || "")
		DONE_DLG.replace(	strh["DONE_DLG"] || "")
		HTML_DONE.replace(	strh["HTML_DONE"] || "")
		HTML_CLOSE.replace(	strh["HTML_CLOSE"] || "")
		HTML_HELP.replace(	strh["HTML_HELP"] || "")
		HTML_OK.replace(	strh["HTML_OK"] || "")
		HTML_CANCEL.replace(strh["HTML_CANCEL"] || "")
		###
		return true
		###
	end
	
  class Cut ####################################################################
	
	include SUPodium_Section_Tool
	
	def logger(txt)
		if DEBUG ### only write the log if DEBUG is set in the loader .rb
			log=File.open(@logpath,'a')
			log.puts(txt.to_s)
			log.close
		end
	end
	
	def initialize()
		###
		### default @vars
		@model=nil
		@ss=nil
		@msg=nil
		@msg1=nil
		@plane=nil
		@aents=nil
		@bb=nil
		@cntr=nil
		@norm=nil
		@section=nil
		@cutter=nil
		@sectioncut=nil
		@gents=nil
		@temp_group=nil
		@dlg=nil
		@dlgX=nil
		@html=""
		@body=""
		@view=nil
		@online=nil
		###
		@online=Sketchup.is_online
		###
		### Make TEMP folder
		### wrap to avoid special chars in user's name File.exist?()==nil incorrectly
		### AND stops fail otherwise...
		begin
			Dir.mkdir(TEMPDIR)
		rescue
			###
		end
		###
		### set main message
		@msg="#{TOOLNAME}: "
		###
		@model=Sketchup.active_model
		@view=@model.active_view
		@ss=@model.selection
		Sketchup.set_status_text(@msg)
		unless @ss.length==1 && @ss[0].is_a?(Sketchup::SectionPlane)
			Sketchup.set_status_text(@msg+SELECT_ONE)
			UI.beep
			webdialogSELECT_ONE()
			return nil
		end ### should never happen !!!
		if @model.path.empty?
			Sketchup.set_status_text(@msg+MUST_SAVE)
			UI.beep
			webdialogMUST_SAVE()
			return nil
		end
		###
		if DEBUG
			@logpath=@model.path+'.log'
			log=File.open(@logpath,'w')
			log.puts("START: #{Time.now}")
			log.puts("#{@model.path}")
			log.close
		end
		###
		### sort out any transformations first...
		### get sectionplane info
		Sketchup.set_status_text(@msg+COLLECTING)
		@section=@ss[0]
		@plane=@section.get_plane
		###
		@tra = Geom::Transformation.new() ### neutral transformations
		@ttr = Geom::Transformation.new()
		if @model.active_path
			mpa = @model.active_path
			until @model.active_entities==@model.entities
				@model.close_active
			end
			mpa.each{|e| @ttr = @ttr * e.transformation }
		end
		###
		### advisor dialog
		Sketchup.set_status_text(@msg)
		UI.beep
		###
		webdialogADVISOR()
		###
		### if NOT canceled we will then "continue()"
		###
	end #####################################
	
	def continue() ##########################
		###
		Sketchup.set_status_text(@msg+COPYING)
		###
		@model=Sketchup.active_model
		@view=@model.active_view
		@ss=@model.selection
		### get current model's path and folder
		mpath=@model.path.tr("\\","/")
		mdir=File.dirname(mpath)
		###
		@tid=Time.now.to_f
		### set enduring tid reference to the sectionplane so available in saved copy.
		@section.set_attribute("SUPodium_Section_Tool", "tid", @tid)
		###
		### now SKP save the as new version
		mdirlen=mpath.length+1
		skp=File.basename(mpath, ".*")
		t=Time.now
		yyyy=t.year.to_s
		mm=t.month
		if mm<10
			mm="0"+mm.to_s
		else
			mm=mm.to_s
		end
		dd=t.day
		if dd<10
			dd="0"+dd.to_s
		else
			dd=dd.to_s
		end
		hh=t.hour
		if hh<10
			hh="0"+hh.to_s
		else
			hh=hh.to_s
		end
		mi=t.min
		if mi<10
			mi="0"+mi.to_s
		else
			mi=mi.to_s
		end
		###
		date = "[x"+yyyy+mm+dd+"_"+hh+mi+"]"
		###
		sskp=skp+date+".skp"
		sskplen=sskp.length+1 ### for NULL character
		### filepath length check/fix
		max=260
		if mdirlen+sskplen >= max
			xskp=skp.split("[")
			xskp.delete_at(1)
			skp=xskp.join("[")
			sskp=skp+date+".skp"
			sskplen=sskp.length+1
		end
		sskppath=File.join(mdir, sskp)
		###
		if Sketchup.version.to_i < 14
			@model.save(sskppath)
		else ### >= v2014
			@model.save_copy(sskppath)
		end
		###
		Sketchup.open_file(sskppath) ### PC it replaces original: MAC opens it with original
		###
		###~~~~~~~~~~~~~~~~~~~~~~~~~~
		###
		@model=Sketchup.active_model ### doubly sure we get newly opened model !
		@view=@model.active_view
		@ss=@model.selection
		###
		if DEBUG
			begin
				File.rename(@logpath, @model.path+'.log')
				@logpath=@model.path+'.log'
			rescue
			end
			logger(@model.path)
		end
		###
		unless IS_MAC ### PC only possibility...
			unless @model.path.tr("\\","/") == sskppath.tr("\\","/")
				### PC user somehow Canceled the orignal's 'Save' < 14
				begin
					File.delete(sskppath)
				rescue
					###
				end
				return nil
			end
		end
		###
		### processing ...
		@msg1=@msg+PROCESSING
		Sketchup.set_status_text(@msg1)
		###
		begin
			@model.start_operation(TOOLNAME, true)
		rescue
			@model.start_operation(TOOLNAME)
		end
		###
		###
		ents=@model.entities
		definitions=@model.definitions
		layers=@model.layers
		materials=@model.materials
		### 1st tidy up
		definitions.purge_unused
		layers.purge_unused
		###
		### NOW !!!
		### we prepare to erase/hide selected sectionplane and get its info
		@aents=ents
		@section=nil
		found=false
		ents.each{|e|
			next unless e.valid? && e.is_a?(Sketchup::SectionPlane)
			if e.get_attribute("SUPodium_Section_Tool", "tid", nil)==@tid
				@section = e ###
				found=true
				break
			end
		}
		unless found
			found=false
			definitions.each{|d|
				d.entities.each{|e|
					next unless e.valid? && e.is_a?(Sketchup::SectionPlane)
					if e.get_attribute("SUPodium_Section_Tool", "tid", nil)==@tid
						@aents = d.entities
						@section = e ###
						found=true
						break
					end
				}
				break if found
			}
		end
		###
		logger(@section)
		###
		unless @section ### THIS SHOULD NEVER HAPPEN !
			UI.messagebox(TOOLNAME+":\n\n"+NOSECTION)
			@model.abort_operation
			return nil
		end
		###
		### We start to get plane details & make the section-cut-face cutter...
		###
		@msg1<<'.';Sketchup.set_status_text(@msg1)
		@bb=@model.bounds ### always more than big enough !
		@cntr=@bb.center.project_to_plane(@plane).transform(@ttr.inverse)
		@norm=Geom::Vector3d.new(@plane[0], @plane[1], @plane[2]).transform(@ttr.inverse).normalize
		###
		radi=@bb.diagonal*2
		###
		### move section 1mm away from @plane and 'hide' section[s]
		nplane=[@cntr.offset(@norm.reverse, 1.mm), @norm]
		@section.set_plane(nplane)
		###
		slayer=layers.add("-OFFSECTS")
		slayer.page_behavior=(LAYER_IS_HIDDEN_ON_NEW_PAGES)
		slayer.visible=false
		sectionplanes_to_off_layer(slayer)
		###
		### AND we 1st remove unused stuff - hidden, off layers, text, dims etc
		@msg1<<'.';Sketchup.set_status_text(@msg1)
		delete_unused(@model.entities)
		@msg1<<'.';Sketchup.set_status_text(@msg1)
		definitions.each{|d| delete_unused(d.entities) }
		###
		### make the 'cutter'
		@msg1<<' .';Sketchup.set_status_text(@msg1)
		@cutter=@aents.add_group()
		@cutter.name="Cutter"
		cents=@cutter.entities
		ceds=cents.add_circle(@cntr, @norm.reverse, radi, 8)
		ceds.each{|e|e.find_faces unless e.faces[0]}
		###
		@msg1<<' >';Sketchup.set_status_text(@msg1)
		### make 'container'
		@sectioncut=@aents.add_group()
		@gents=@sectioncut.entities
		cpt=@gents.add_cpoint(ORIGIN) ### keeper
		### intersect cutter with aents and add edges to container 'sectioncut'
		@aents.intersect_with(true, @sectioncut.transformation, @gents, @cutter.transformation, true, @cutter)
		###
		logger(GP_NAME)
		logger("#{@sectioncut} #{@sectioncut.entities.length}")
		###
		if @gents.length > 1 ### i.e. not just a cpoint
			cpt.erase!
			@sectioncut.name=GP_NAME
			#return nil
			### face the cuts
			@msg1<<'>';Sketchup.set_status_text(@msg1)
			@gents.grep(Sketchup::Edge).each{|e|e.find_faces}
			### divide up face with intersections
			@msg1<<'> ';Sketchup.set_status_text(@msg1)
			@gents.intersect_with(true, @tra, @gents, @tra, true, @gents.to_a)
			###
			### force splits of faces
			tgp=@gents.add_group()
			tents=tgp.entities
			@gents.grep(Sketchup::Edge).each{|e|
				@msg1<<'|';Sketchup.set_status_text(@msg1)
				tents.add_line(e.start.position, e.start.position.offset(@norm))
				tents.add_line(e.end.position, e.end.position.offset(@norm))
			}
			tgp.explode
			togos=[]
			@gents.grep(Sketchup::Edge).each{|e|togos << e if e.line[1].parallel?(@norm)}
			@gents.erase_entities(togos) if togos[0]
			###
			### re-find faces
			@gents.grep(Sketchup::Edge).each{|e|e.find_faces}
			@gents.grep(Sketchup::Edge).each{|e|e.find_faces unless e.faces[0]}
			@gents.intersect_with(true, @tra, @gents, @tra, true, @gents.to_a)
			###
			### color face to match section cut
			@msg1<<' .';Sketchup.set_status_text(@msg1)
			smat=GP_MAT
			unless mat=materials[smat]
				mat=materials.add(smat) 
				mat.color=@model.rendering_options["SectionDefaultCutColor"]
			end
			###
			@sectioncut.material=mat
			###
			@gents.grep(Sketchup::Face).each{|face|
				face.reverse! if face.normal==@norm ### face out
				face.material=mat
				face.back_material=mat
			}
			###
			### sort out holes etc in @sectioncut group
			@msg1<<' . ';Sketchup.set_status_text(@msg1)
			faces=@gents.grep(Sketchup::Face)
			(faces.length-1).times{
				faces.each{|face|
					next unless face.valid?
					face.outer_loop.edgeuses.each{|edgeuse|
						unless edgeuse.partners[0] ### outermost face
							faces = faces - [face]
							face.loops.each{|loop|
								faces.each{|fac|
									next unless fac.valid?
									if fac.outer_loop.edges - loop.edges == []
										faces = faces - [fac]
										fac.erase! if fac.valid?
										### fac abutts kept face so it must be erased...
									end#if fac
								}#fac
							}#loop
						end#if outermost
					}#edgeuse
				}#face
			}#times
			###
		else
			@gents.clear! if @sectioncut.valid?
			@sectioncut=nil ###
		end### if gents !
		###
		#return nil
		###
		@cutter.layer=slayer
		begin
			#@view.refresh
			#@view.invalidate
		rescue
		end
		###
		#return nil
		### Now we commence cutting the model 'in half'...
		###
		#return nil
		### make split containers unique etc
		logger('Uniquify...')
		@msg1<<' >';Sketchup.set_status_text(@msg1)
		uniquify(@aents, @ttr)
		###
		#return nil
		### make cuts !
		logger('Cut_nested...')
		@msg1<<'>';Sketchup.set_status_text(@msg1)
		cut_nested(@aents.parent, @tra)
		###
		#return nil
		## finally, deletions !
		logger('Delete_from_container...')
		@msg1<<'> ';Sketchup.set_status_text(@msg1)
		delete_from_container?(@aents.parent, @ttr)
		###
		begin
			#@view.refresh
			#@view.invalidate
		rescue
		end
		#return nil
		logger('@cutter.entities.clear!')
		### finally remove unneeded @cutter
		@msg1<<' .';Sketchup.set_status_text(@msg1)
		@cutter.entities.clear! if @cutter && @cutter.valid?
		###
		logger('@temp_group.entities.clear!')
		### and tidy up @temp_group
		@msg1<<'.';Sketchup.set_status_text(@msg1)
		@temp_group.entities.clear! if @temp_group && @temp_group.valid?
		###
		### purges
		logger('Purges...')
		@msg1<<' .';Sketchup.set_status_text(@msg1)
		definitions.purge_unused
		materials.purge_unused
		layers.purge_unused
		###
		Sketchup.set_status_text(@msg+SAVING)
		###
		logger("Save changes: #{Time.now}")
		UI.start_timer(0, false){
			Sketchup.send_action("saveDocument:")
			### try to remove unwanted SKB, if any !
			if IS_MAC
				sskbpath = sskppath.gsub(/.skp$/, "~.skp")
			else #PC
				sskbpath = sskppath.gsub(/.skp$/, ".skb")
			end			
			UI.start_timer(2.0, false){
				begin
					File.delete(sskbpath) if File.exist?(sskbpath)
				rescue
					###
				end
			}
		}
		###
		if @sectioncut && @sectioncut.valid?
			@ss.clear
			defn=@sectioncut.entities.parent
			defn.invalidate_bounds
			@ss.add(@sectioncut)
			###
		end
		###
		@model.commit_operation
		###
		begin
			#@view.refresh
			#@view.invalidate
		rescue
		end
		###
		### closing msg
		Sketchup.set_status_text(@msg)
		webdialogDONE()
		###
		logger("DONE: #{Time.now}")
		if DEBUG && @logpath && File.exist?(@logpath) && ! SAVE_REPORT
			File.delete(@logpath)
		end
		###
		Sketchup.send_action("selectSelectTool:")
		###
	end
	
	def closer()
		return nil
	end
	
	###############
	
	def make_html()
		@html=<<HTML_END   
<html>
  <head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<meta http-equiv="Content-Script-Type" content="text/javascript;">
	<style type="text/css">
	  html {
		font-family: Arial,Helvetica,sans-serif;
		font-size: 10pt;
	  }
	  input,submit,button {
	    align: center;
		font-size: 10pt;
		width: 100%;
	  }
	  table,tr,td {
		font-size: 10pt;
		width: 100%;
	  }
	</style>
  </head>
  <body>
	#{@body}
  </body>
</html>
HTML_END
	end
	
	###################

	def make_dlg()
		@dlg=UI::WebDialog.new("", false, nil, 1, 1, 1, 1, false)
	end
	
	def make_dlgX()
		@dlgX=UI::WebDialog.new("", true, nil, 1, 1, 1, 1, true)
	end
	
	def webdialogSELECT_ONE()
		w=@view.vpwidth
		h=@view.vpheight
		dw=232
		dh=215
		pw=w/2
		ph=h/2
		###
		make_dlg()
		@dlg.set_size(dw, dh)
		@dlg.set_position(pw, ph)
		txta = SELECT_ONE.split("\n")
		txts = txta.join("<br>\n")
		@body=<<HTML_END   
<table>
  <tr><b>
	<p>
#{TOOLNAME}:
	</p></b>
  </tr>
  <tr>
	<p>
#{txts}
	</p>
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_OK}" onclick="window.location='skp:ok_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		f=File.open(TEMPHTML, 'w')
		f.puts(@html)
		f.close
		@dlg.set_file(TEMPHTML)
		###
		@dlg.add_action_callback("ok_dlg"){|d,p| @dlg.close }
		###
		UI.beep
		@dlg.show_modal{}
		###
	end
	
	def webdialogMUST_SAVE()
		w=@view.vpwidth
		h=@view.vpheight
		dw=232
		dh=234
		pw=w/2
		ph=h/2
		###
		make_dlg()
		@dlg.set_size(dw, dh)
		@dlg.set_position(pw, ph)
		txta = MUST_SAVE.split("\n")
		txts = txta.join("<br>\n")
		@body=<<HTML_END   
<table>
  <tr><b>
	<p>
#{TOOLNAME}:
	</p></b>
  </tr>
  <tr>
	<p>
#{txts}
	</p>
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_OK}" onclick="window.location='skp:ok_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		f=File.open(TEMPHTML, 'w')
		f.puts(@html)
		f.close
		@dlg.set_file(TEMPHTML)
		###
		@dlg.add_action_callback("ok_dlg"){|d,p| @dlg.close }
		###
		UI.beep
		@dlg.show_modal{}
		###
	end
	
	def webdialogADVISOR()
		w=@view.vpwidth
		h=@view.vpheight
		dw=333
		dh=230
		pw=w/2
		ph=h/2
		###
		make_dlg()
		@dlg.set_size(dw, dh)
		@dlg.set_position(pw, ph)
		txta = ADVISOR.split("\n")
		txts = txta.join("<br>\n")
		@body=<<HTML_END   
<table>
  <tr><b>
	<p>
#{TOOLNAME}:
	</p></b>
  </tr>
  <tr>
	<p>
#{txts}
	</p>
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_OK}" onclick="window.location='skp:ok_dlg@'">
	</td>
	<td>
		<input type="button" value="#{HTML_HELP}" onclick="window.location='skp:help_dlg@'">
	</td>
	<td>
		<input type="button" value="#{HTML_CANCEL}" onclick="window.location='skp:cancel_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		### temp tests TIG
		begin
			f=File.open(TEMPHTML, 'w')
			f.puts(@html)
			f.close
		rescue
			UI.messagebox("Can't write file:\n#{TEMPHTML}")
			return nil
		end
		###
		@dlg.set_file(TEMPHTML)
		###
		@dlg.add_action_callback("ok_dlg"){|d,p|
			@dlg.close
			continue() ### separate method !
		}
		@dlg.add_action_callback("help_dlg"){|d,p|
			if @online
				UI.openURL(HELP_URL)
			else
				webdialogHELP()
			end			
		}
		@dlg.add_action_callback("cancel_dlg"){|d,p|
			@dlg.close
			return nil
		}
		###
		UI.beep
		@dlg.show_modal{} ### MAC wait
		###
	end
	
	def webdialogHELP()
		w=@view.vpwidth
		h=@view.vpheight
		dw=450
		dh=700
		pw=w/2
		ph=h/5
		###
		make_dlgX()
		@dlgX.set_size(dw, dh)
		@dlgX.set_position(pw, ph)
		txta = HELP_DLG.split("\n")
		txts = txta.join("<br>\n")
		txts.gsub!(/[=][|][=]/, '==')
		@body=<<HTML_END
<table>
  <tr>
	<p><b>
#{TOOLNAME}:
	</p></b>
  </tr>
	</p>
  <tr>
	<p>
#{txts}
	</p>		
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_CLOSE}" onclick="window.location='skp:close_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		f=File.open(TEMPHTML, 'w')
		f.puts(@html)
		f.close
		@dlgX.set_file(TEMPHTML)
		###
		@dlgX.add_action_callback("close_dlg"){|d,p| @dlgX.close }
		###
		UI.beep
		@dlgX.show_modal{}
		###
	end
	
	def webdialogDONE()
		@dlg.close if @dlg && @dlg.visible?
		w=@view.vpwidth
		h=@view.vpheight
		dw=333
		dh=230
		pw=w/2
		ph=h/2
		###
		make_dlg()
		@dlg.set_size(dw, dh)
		@dlg.set_position(pw, ph)
		txta = HTML_DONE.split("\n")
		txts = txta.join("<br>\n")
		@body=<<HTML_END   
<table>
  <tr>
	<p><b>
#{TOOLNAME}:
	</p></b>
  </tr>
	</p>
  <tr>
	<p>
#{txts}
	</p>		
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_CLOSE}" onclick="window.location='skp:close_dlg@'">
	</td>
	<td>
		<input type="button" value="#{HTML_HELP}" onclick="window.location='skp:help_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		f=File.open(TEMPHTML, 'w')
		f.puts(@html)
		f.close
		@dlg.set_file(TEMPHTML)
		###
		@dlg.add_action_callback("close_dlg"){|d,p|
			@dlg.close
		}
		@dlg.add_action_callback("help_dlg"){|d,p|
			if @online
				UI.openURL(HELP_URL)
			else
				webdialogDONEHELP()
			end
			@dlg.close
		}
		###
		@dlg.set_on_close{closer()}
		UI.beep
		@dlg.show{}
		### auto-close
		tim=UI.start_timer(0.1, true){
			unless @model.modified?
				UI.start_timer(2, false){
					begin
						@dlg.close
					rescue
					end
				}
				UI.stop_timer(tim)
			end
		}
		###
	end
	
	def webdialogDONEHELP()
		w=@view.vpwidth
		h=@view.vpheight
		dw=450
		dh=668
		pw=w/2
		ph=h/5
		###
		make_dlgX()
		@dlgX.set_size(dw, dh)
		@dlgX.set_position(pw, ph)
		txta = DONE_DLG.split("\n")
		txts = txta.join("<br>\n")
		@body=<<HTML_END   
<table>
  <tr>
	<p><b>
#{TOOLNAME}:
	</p></b>
  </tr>
	</p>
  <tr>
	<p>
#{txts}
	</p>		
  </tr>
  <tr>
	<td>
		<input type="submit" value="#{HTML_CLOSE}" onclick="window.location='skp:close_dlg@'">
	</td>
  </tr>
</table>
HTML_END
		make_html()
		###
		f=File.open(TEMPHTML, 'w')
		f.puts(@html)
		f.close
		@dlgX.set_file(TEMPHTML)
		###
		@dlgX.add_action_callback("close_dlg"){|d,p| @dlgX.close }
		###
		UI.beep
		@dlgX.show_modal{}
		###
	end
	
	###################
	
	def sectionplanes_to_off_layer(slayer=nil) ###v1.4
		retrun nil unless slayer
		@model.entities.grep(Sketchup::SectionPlane).each{|e|
			e.layer=slayer
		}
		@model.definitions.each{|d|
			next if d.image?
			d.entities.grep(Sketchup::SectionPlane).each{|e|
				e.layer=slayer
			}
		}
	end
		
	def delete_unused(ents)
		togos=[]
		ents.to_a.each{|e|
			next unless e.valid? && e.is_a?(Sketchup::Image) ### ?
			defn=nil
			@model.definitions.each{|d|
				if d.image? && d.instances.include?(e)
					defn=d
					break
				end
			}
			if defn
				defn.entities.grep(Sketchup::Edge).each{|ed|
					ed.hidden=true
				}
			end
			e.explode ### ??? best for rendering ?
		}
		###
		ents.to_a.each{|e|
			next unless e.valid?
			next if e.is_a?(Sketchup::SectionPlane)
			delete_unused(e.entities) if e.is_a?(Sketchup::Group)
			delete_unused(e.definition.entities) if e.is_a?(Sketchup::ComponentInstance)
			###
			### remove ALL hidden drawingelements - save faced-edges
			if e.respond_to?(:hidden?)
				if e.hidden?
					if e.is_a?(Sketchup::Edge)
						ff=true
						e.faces.each{|f|
							if f.visible?
								ff=false
								break
							end
						}
						togos << e if ff
					else
						togos << e
					end
				end
			end
			### remove ALL drawingelements on OFF layers - save faced-edges
			if e.respond_to?(:layer)
				unless e.layer.visible?
					if e.is_a?(Sketchup::Edge)
						ff=true
						e.faces.each{|f|
							if f.layer.visible?
								ff=false
								break
							end
						}
						togos << e if ff
					else
						togos << e
					end
				end
			end
			### remove clines
			togos << e if e.is_a?(Sketchup::ConstructionLine)
			### remove cpoints
			togos << e if e.is_a?(Sketchup::ConstructionPoint)
			### remove text
			togos << e if e.is_a?(Sketchup::Text)
			### remove dims
			togos << e if e.typename=~/Dimension/
			###
		}
		togos.uniq!
		togos.dup.each{|e| togos.delete(e) unless e.valid? }
		ents.erase_entities(togos) if togos[0]
	end
	
	def uniquify(ents, t)
		#p ents.count
		togos=[]
		ents.each{|e|
			next unless e.valid?
			next if (@cutter && e==@cutter) || (@sectioncut && e==@sectioncut) || (@temp_group && e==@temp_group)
			if e.is_a?(Sketchup::Group)
				intersect=intersect_plane?(e, t)
				if intersect==0  ### intersects plane
					e.make_unique if e.entities.parent.instances[1]
					uniquify(container_entities(e), t*e.transformation)
				elsif intersect==-1  ### wholly behind plane
					togos << e
				end	
			end
			if e.is_a?(Sketchup::ComponentInstance)
				intersect=intersect_plane?(e, t)
				if intersect==0  ### intersects plane
					e.make_unique if e.definition.instances[1]
					uniquify(container_entities(e), t*e.transformation)
				elsif intersect==-1  ### wholly behind plane
					togos << e
				end	
			end
		}
		###
		ents.erase_entities(togos) if togos[0]
		###
	end
	
	def intersect_plane?(container, t)
		obb = container.bounds
		pts = []
		8.times{|i| pts << obb.corner(i) }
		###
		pts=pts.collect{|p| p.transform(t) }
		###
		behind = nil
		before = nil
		behind = pts.find{|p| (@plane[0]*p.x+@plane[1]*p.y+@plane[2]*p.z+@plane[3]) < 0.0 }
		before = pts.find{|p| (@plane[0]*p.x+@plane[1]*p.y+@plane[2]*p.z+@plane[3]) > 0.0 }
		if behind != nil && before != nil
			return 0
		elsif behind != nil && before == nil
			return -1
		elsif behind == nil && before != nil 
			return 1
		end
	end
	
	def cut_nested(container, t1)
		return nil if (@cutter && container==@cutter) || (@sectioncut && container==@sectioncut) || (@temp_group && container==@temp_group)
		logger("Cut_nested #{container}")
		logger("'#{container.definition.name}' '#{container.name}'") if container.is_a?(Sketchup::ComponentInstance)
		logger("'#{container.name}'") if container.is_a?(Sketchup::Group)
		return nil unless ents=container_entities(container)
		ents.each{|e|
			next unless e.valid?
			next if (@cutter && e==@cutter) || (@sectioncut && e==@sectioncut) || (@temp_group && e==@temp_group)
			if e.class==Sketchup::Group || e.class==Sketchup::ComponentInstance
				cut_nested(e, t1*e.transformation)
			end
		}
		logger("Cut_nested==Cut")
		cut(container, t1)
	end
	
	def cut(container, t1)
		return nil if (@cutter && container==@cutter) || (@sectioncut && container==@sectioncut) || (@temp_group && container==@temp_group)
		return nil unless ents=container_entities(container)
		logger("Cut ents OK")
		if intersects_with_plane?(container, t1)
			logger("Cut INTERSECTS:\nTransformation:")
			logger("#{t1.to_a.join("\n")}")
			togos=[]
			logger("Cut Nents:")
			nents = ents.intersect_with(true, t1, ents, t1*@cutter.transformation, true, @cutter)
			logger("#{nents.join("\n")}")
			nedges = nents.grep(Sketchup::Edge) if nents && nents[0]
			nnents=ents.intersect_with(true, t1, ents, t1, true, nedges) if nedges && nedges[0]
			nnedges = nnents.grep(Sketchup::Edge) if nnents && nnents[0]
			nnnents = ents.intersect_with(true, t1, ents, t1, true, nnedges) if nnedges && nnedges[0]
			nnnents.grep(Sketchup::Edge).each{|e| togos << e unless e.faces[0] } if nnnents && nnnents[0]
			### e.g. from cut through group etc
			logger("Togos:\n#{togos.join("\n")}")
			ents.erase_entities(togos) if togos[0]
		else ### no cut
			return nil
		end
	end
	
	def container_entities(container)
		if container.is_a?(Sketchup::Model)
			return container.entities
		elsif container.is_a?(Sketchup::Group)
			return container.entities
		elsif container.is_a?(Sketchup::ComponentInstance)
			return container.definition.entities
		elsif container.is_a?(Sketchup::ComponentDefinition)
			return container.entities ### unlikely ???
		else
			return nil ### this should never happen !
		end
	end

	def intersects_with_plane?(container, t1)
		return nil unless ents=container_entities(container)
		if @temp_group && @temp_group.valid?
			@temp_group.entities.clear!
			@temp_group.entities.add_cpoint(ORIGIN)
		else
			@temp_group=@aents.add_group()
			@temp_group.entities.add_cpoint(ORIGIN)
			@temp_group.name="temp_group"
		end
		nents = ents.intersect_with(true, t1, @temp_group.entities, @temp_group.transformation, true, @cutter)
		if nents.grep(Sketchup::Edge).length > 0
			return true
		else
			return false
		end
	end
	
	def delete_from_container?(container, t1)
		return nil if (@cutter && container==@cutter) || (@sectioncut && container==@sectioncut)  || (@temp_group && container==@temp_group)
		return nil unless ents=container_entities(container)
		ents.each{|e|
			next unless e.valid?
			if e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
				delete_from_container?(e, t1*e.transformation)
			end
		}
		delete_edges(container, t1)
	end
	
	def delete_edges(container, t1)
		return nil if (@cutter && container==@cutter) || (@sectioncut && container==@sectioncut)  || (@temp_group && container==@temp_group)
		return nil unless ents=container_entities(container)
		togos=[]
		ents.each{|e|
			next unless e.valid? && e.is_a?(Sketchup::Edge)
			p1=e.start.position
			p2=e.end.position
			p1=p1.transform(t1)
			p2=p2.transform(t1)
			mid=[(p1.x+p2.x)/2.0, (p1.y+p2.y)/2.0, (p1.z+p2.z)/2.0]
			res=@plane[0]*mid.x+@plane[1]*mid.y+@plane[2]*mid.z+@plane[3]
			togos << e if res<0 && mid.distance_to_plane(@plane)>0.001 #???
		}
		ents.erase_entities(togos) if togos[0]
	end	
	
  end#class ####################################################################
  
end#module #####################################################################
